; burneye cryptographic layer 1 & 2 cracker
; by [ByteRage] / UNF
;
; (C) Copyright UNF security, 2002
; All Rights Reserved

section .data

pad1            db 080h

padnull		dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
		dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

msgblock        dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

section .text

global SHA1Hash

memcpy:
                push    ebx
                mov     ebx, [esp+8]
                mov     ecx, [esp+0Ch]
                mov     edx, [esp+10h]
                dec     edx
                cmp     edx, 0FFFFFFFFh
                jz      short skipcpy
nextbyte:
                mov     al, [ecx]
                mov     [ebx], al
                inc     ecx
                inc     ebx
                sub	edx, 1
                jnb     short nextbyte
skipcpy:
                pop     ebx
                retn

SHA1ProcessMessageBlock:
                push    ebp
                mov     ebp, esp
                sub     esp, 15Ch
                push    edi
                push    esi
                push    ebx
                mov     esi, dword [ebp+0Ch]
		mov     edi, dword msgblock
		mov	ecx, 010h
		rep	movsd
		mov     eax, [ebp+8]
                mov     esi, [eax]
                mov     ebx, [eax+4]
                mov     ecx, [eax+8]
                mov     edx, [eax+0Ch]
		mov	edi, edx
                mov     eax, ecx
                xor     eax, edx
                and     eax, ebx
                xor     eax, edx
                add     eax, dword [msgblock]
		mov	edx, esi
		rol	edx, 5
		mov	[ebp-0Ch], edx
                lea     eax, [eax+edx+5A827999h]
                mov     edx, [ebp+8]
                mov     edx, [edx+10h]
                add     eax, edx
		mov     esp, eax
		rol     ebx, 1Eh
                mov     edx, ebx
                xor     edx, ecx
                and     edx, esi
                xor     edx, ecx
                mov     eax, dword [msgblock+4]
                mov     [ebp-114h], eax
                add     edx, eax
                mov     eax, esp
		rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
		add	edi, eax
                rol     esi, 1Eh
                mov     edx, esi
                xor     edx, ebx
		and     edx, esp
		xor     edx, ebx
                mov     eax, dword [msgblock+8]
                mov     [ebp-118h], eax
                add     edx, eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     ecx, eax
		rol     esp, 1Eh
		mov     edx, esp
                xor     edx, esi
		and	edx, edi
                xor     edx, esi
                mov     eax, dword [msgblock+0Ch]
                mov     [ebp-11Ch], eax
                add     edx, eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     ebx, eax
		rol	edi, 1Eh
		mov	edx, edi
		xor	edx, esp
                and     edx, ecx
		xor	edx, esp
                mov     eax, dword [msgblock+10h]
                mov     [ebp-120h], eax
                add     edx, eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ecx
		xor	edx, edi
                and     edx, ebx
		xor	edx, edi
                mov     eax, dword [msgblock+14h]
                mov     [ebp-124h], eax
                add     edx, eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
		add	esp, eax
                rol     ebx, 1Eh
                mov     edx, ebx
                xor     edx, ecx
                and     edx, esi
                xor     edx, ecx
                mov     eax, dword [msgblock+18h]
                mov     [ebp-128h], eax
                add     edx, eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
		add	edi, eax
                rol     esi, 1Eh
                mov     edx, esi
                xor     edx, ebx
		and	edx, esp
                xor     edx, ebx
                mov     eax, dword [msgblock+1Ch]
                mov     [ebp-12Ch], eax
                add     edx, eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	edx, esp
                xor     edx, esi
		and	edx, edi
                xor     edx, esi
                mov     eax, dword [msgblock+20h]
                mov     [ebp-130h], eax
                add     edx, eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     ebx, eax
		rol	edi, 1Eh
		mov	edx, edi
		xor	edx, esp
                and     edx, ecx
		xor	edx, esp
                mov     eax, dword [msgblock+24h]
                mov     [ebp-134h], eax
                add     edx, eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ecx
		xor	edx, edi
                and     edx, ebx
		xor	edx, edi
                mov     eax, dword [msgblock+28h]
                mov     [ebp-138h], eax
                add     edx, eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
		add	esp, eax
                rol     ebx, 1Eh
                mov     edx, ebx
                xor     edx, ecx
                and     edx, esi
                xor     edx, ecx
                mov     eax, dword [msgblock+2Ch]
                mov     [ebp-13Ch], eax
                add     edx, eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
		add	edi, eax
                rol     esi, 1Eh
                mov     edx, esi
                xor     edx, ebx
		and	edx, esp
                xor     edx, ebx
                mov     eax, dword [msgblock+30h]
                mov     [ebp-140h], eax
                add     edx, eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	edx, esp
                xor     edx, esi
		and	edx, edi
                xor     edx, esi
                mov     eax, dword [msgblock+34h]
                mov     [ebp-144h], eax
                add     edx, eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     ebx, eax
		rol	edi, 1Eh
		mov	edx, edi
		xor	edx, esp
                and     edx, ecx
		xor	edx, esp
                mov     eax, dword [msgblock+38h]
                mov     [ebp-148h], eax
                add     edx, eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ecx
		xor	edx, edi
                and     edx, ebx
		xor	edx, edi
                mov     eax, dword [msgblock+3Ch]
                mov     [ebp-14Ch], eax
                add     edx, eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
		add	esp, eax
                rol     ebx, 1Eh
		mov	eax, [ebp-144h]
                mov     edx, ebx
		xor	eax, [ebp-130h]
                xor     edx, ecx
		xor	eax, [ebp-118h]
                and     edx, esi
		xor	eax, dword [msgblock]
                xor     edx, ecx
		rol	eax, 1
		add	edx, eax
		mov	[ebp-10h], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
		add	edi, eax
                rol     esi, 1Eh
		mov 	eax, [ebp-148h]
                mov     edx, esi
		xor	eax, [ebp-134h]
                xor     edx, ebx
		xor	eax, [ebp-11Ch]
		and	edx, esp
		xor	eax, [ebp-114h]
                xor     edx, ebx
		rol	eax, 1
		add	edx, eax
		mov	[ebp-14h], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	eax, [ebp-14Ch]
		mov	edx, esp
		xor	eax, [ebp-138h]
                xor     edx, esi
		xor	eax, [ebp-120h]
		and	edx, edi
		xor	eax, [ebp-118h]
                xor     edx, esi
		rol	eax, 1
		add	edx, eax
		mov	[ebp-18h], eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     ebx, eax
                rol	edi, 1Eh
		mov	eax, [ebp-10h]
		mov	edx, edi
		xor	eax, [ebp-13Ch]
		xor	edx, esp
		xor	eax, [ebp-124h]
                and     edx, ecx
		xor	eax, [ebp-11Ch]
		xor	edx, esp
		rol	eax, 1
		add	edx, eax
		mov	[ebp-1Ch], eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax+5A827999h]
                add     esi, eax
                rol     ecx, 1Eh
		mov	eax, [ebp-14h]
                mov     edx, ebx
		xor	eax, [ebp-140h]
                xor     edx, ecx
		xor	eax, [ebp-128h]
		xor	edx, edi
		xor	eax, [ebp-120h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-20h], eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
		add	esp, eax
                rol     ebx, 1Eh
		mov	eax, [ebp-18h]
                mov     edx, esi
		xor	eax, [ebp-144h]
                xor     edx, ebx
		xor	eax, [ebp-12Ch]
                xor     edx, ecx
		xor	eax, [ebp-124h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-24h], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add	edi, eax
		rol     esi, 1Eh
		mov	eax, [ebp-1Ch]
		mov	edx, esp
		xor	eax, [ebp-148h]
                xor     edx, esi
		xor	eax, [ebp-130h]
                xor     edx, ebx
		xor	eax, [ebp-128h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-28h], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	eax, [ebp-20h]
		mov	edx, edi
		xor	eax, [ebp-14Ch]
		xor	edx, esp
		xor	eax, [ebp-134h]
                xor     edx, esi
		xor	eax, [ebp-12Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-2Ch], eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     ebx, eax
		rol	edi, 1Eh
		mov	eax, [ebp-24h]
                mov     edx, ecx
		xor	eax, [ebp-10h]
		xor	edx, edi
		xor	eax, [ebp-138h]
		xor	edx, esp
		xor	eax, [ebp-130h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-30h], eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     esi, eax
                rol     ecx, 1Eh
		mov	eax, [ebp-28h]
                mov     edx, ebx
		xor	eax, [ebp-14h]
                xor     edx, ecx
		xor	eax, [ebp-13Ch]
		xor	edx, edi
		xor	eax, [ebp-134h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-34h], eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
		add	esp, eax
                rol     ebx, 1Eh
		mov	eax, [ebp-2Ch]
                mov     edx, esi
		xor	eax, [ebp-18h]
                xor     edx, ebx
		xor	eax, [ebp-140h]
                xor     edx, ecx
		xor	eax, [ebp-138h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-38h], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
		add	edi, eax
                rol     esi, 1Eh
		mov	eax, [ebp-30h]
		mov	edx, esp
		xor	eax, [ebp-1Ch]
                xor     edx, esi
		xor	eax, [ebp-144h]
                xor     edx, ebx
		xor	eax, [ebp-13Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-3Ch], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     ecx, eax
		rol	esp, 1Eh
                mov     eax, [ebp-34h]
		mov	edx, edi
		xor	eax, [ebp-20h]
		xor	edx, esp
		xor	eax, [ebp-148h]
                xor     edx, esi
		xor	eax, [ebp-140h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-40h], eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     ebx, eax
		rol	edi, 1Eh
		mov	eax, [ebp-38h]
                mov     edx, ecx
		xor	eax, [ebp-24h]
		xor	edx, edi
		xor	eax, [ebp-14Ch]
		xor	edx, esp
		xor	eax, [ebp-144h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-44h], eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     esi, eax
                rol     ecx, 1Eh
                mov	eax, [ebp-3Ch]
                mov     edx, ebx
		xor	eax, [ebp-28h]
                xor     edx, ecx
		xor	eax, [ebp-10h]
		xor	edx, edi
		xor	eax, [ebp-148h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-48h], eax
		mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
		add	esp, eax
                rol     ebx, 1Eh
                mov	eax, [ebp-40h]
                mov     edx, esi
		xor	eax, [ebp-2Ch]
                xor     edx, ebx
		xor	eax, [ebp-14h]
                xor     edx, ecx
		xor	eax, [ebp-14Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-4Ch], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
		add	edi, eax
                rol     esi, 1Eh
                mov	eax, [ebp-44h]
		mov	edx, esp
		xor	eax, [ebp-30h]
                xor     edx, esi
		xor	eax, [ebp-18h]
                xor     edx, ebx
		xor	eax, [ebp-10h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-50h], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	eax, [ebp-48h]
		mov	edx, edi
		xor	eax, [ebp-34h]
		xor	edx, esp
		xor	eax, [ebp-1Ch]
                xor     edx, esi
		xor	eax, [ebp-14h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-54h], eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     ebx, eax
		rol	edi, 1Eh
		mov	eax, [ebp-4Ch]
                mov     edx, ecx
		xor	eax, [ebp-38h]
		xor	edx, edi
		xor	eax, [ebp-20h]
		xor	edx, esp
		xor	eax, [ebp-18h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-58h], eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     esi, eax
                rol     ecx, 1Eh
                mov	eax, [ebp-50h]
                mov     edx, ebx
		xor	eax, [ebp-3Ch]
                xor     edx, ecx
		xor	eax, [ebp-24h]
		xor	edx, edi
		xor	eax, [ebp-1Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-5Ch], eax
		mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
		add	esp, eax
                rol     ebx, 1Eh
                mov	eax, [ebp-54h]
                mov     edx, esi
		xor	eax, [ebp-40h]
                xor     edx, ebx
		xor	eax, [ebp-28h]
                xor     edx, ecx
		xor	eax, [ebp-20h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-60h], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
		add	edi, eax
                rol     esi, 1Eh
		mov	eax, [ebp-58h]
		mov	edx, esp
		xor	eax, [ebp-44h]
                xor     edx, esi
		xor	eax, [ebp-2Ch]
                xor     edx, ebx
		xor	eax, [ebp-24h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-64h], eax
		mov	eax, edi
		rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     ecx, eax
		rol	esp, 1Eh
                mov	eax, [ebp-5Ch]
		mov	edx, edi
		xor	eax, [ebp-48h]
		xor	edx, esp
		xor	eax, [ebp-30h]
                xor     edx, esi
		xor	eax, [ebp-28h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-68h], eax
		mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     ebx, eax
		rol	edi, 1Eh
		mov	eax, [ebp-60h]
                mov     edx, ecx
		xor	eax, [ebp-4Ch]
		xor	edx, edi
		xor	eax, [ebp-34h]
		xor	edx, esp
		xor	eax, [ebp-2Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-6Ch], eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax+6ED9EBA1h]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ebx
                or      edx, ecx
		and	edx, edi
                mov     eax, ebx
                and     eax, ecx
                or      edx, eax
		mov	eax, [ebp-64h]
		xor	eax, [ebp-50h]
		xor	eax, [ebp-38h]
		xor	eax, [ebp-30h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-70h], eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
		add	esp, eax
                rol     ebx, 1Eh
                mov     edx, esi
                or      edx, ebx
                and     edx, ecx
                mov     eax, esi
                and     eax, ebx
                or      edx, eax
		mov	eax, [ebp-68h]
		xor	eax, [ebp-54h]
		xor	eax, [ebp-3Ch]
		xor	eax, [ebp-34h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-74h], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
		add	edi, eax
                rol     esi, 1Eh
		mov	edx, esp
                or      edx, esi
                and     edx, ebx
		mov	eax, esp
                and     eax, esi
                or      edx, eax
		mov	eax, [ebp-6Ch]
		xor	eax, [ebp-58h]
		xor	eax, [ebp-40h]
		xor	eax, [ebp-38h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-78h], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	edx, edi
		or	edx, esp
                and     edx, esi
		mov	eax, edi
		and	eax, esp
                or      edx, eax
		mov	eax, [ebp-70h]
		xor	eax, [ebp-5Ch]
		xor	eax, [ebp-44h]
		xor	eax, [ebp-3Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-7Ch], eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     ebx, eax
		rol	edi, 1Eh
                mov     edx, ecx
		or	edx, edi
		and	edx, esp
                mov     eax, ecx
		and	eax, edi
                or      edx, eax
                mov	eax, [ebp-74h]
		xor	eax, [ebp-60h]
		xor	eax, [ebp-48h]
		xor	eax, [ebp-40h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-80h], eax		
		mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ebx
                or      edx, ecx
		and	edx, edi
                mov     eax, ebx
                and     eax, ecx
                or      edx, eax
                mov	eax, [ebp-78h]
		xor	eax, [ebp-64h]
		xor	eax, [ebp-4Ch]
		xor	eax, [ebp-44h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-84h], eax
		mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
		add	esp, eax
                rol     ebx, 1Eh
                mov     edx, esi
                or      edx, ebx
                and     edx, ecx
                mov     eax, esi
                and     eax, ebx
                or      edx, eax
		mov	eax, [ebp-7Ch]
		xor	eax, [ebp-68h]
		xor	eax, [ebp-50h]
		xor	eax, [ebp-48h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-88h], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
		add	edi, eax
                rol     esi, 1Eh
		mov	edx, esp
                or      edx, esi
                and     edx, ebx
		mov	eax, esp
                and     eax, esi
                or      edx, eax
		mov	eax, [ebp-80h]
		xor	eax, [ebp-6Ch]
		xor	eax, [ebp-54h]
		xor	eax, [ebp-4Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-8Ch], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	edx, edi
		or	edx, esp
                and     edx, esi
		mov	eax, edi
		and	eax, esp
                or      edx, eax
                mov	eax, [ebp-84h]
		xor	eax, [ebp-70h]
		xor	eax, [ebp-58h]
		xor	eax, [ebp-50h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-90h], eax
		mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     ebx, eax
		rol	edi, 1Eh
                mov     edx, ecx
		or	edx, edi
		and	edx, esp
                mov     eax, ecx
		and	eax, edi
                or      edx, eax
		mov	eax, [ebp-88h]
		xor	eax, [ebp-74h]
		xor	eax, [ebp-5Ch]
		xor	eax, [ebp-54h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-94h], eax
                mov     eax, ebx
		
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ebx
                or      edx, ecx
		and	edx, edi
                mov     eax, ebx
                and     eax, ecx
                or      edx, eax
		mov	eax, [ebp-8Ch]
		xor	eax, [ebp-78h]
		xor	eax, [ebp-60h]
		xor	eax, [ebp-58h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-98h], eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
		add	esp, eax
                rol     ebx, 1Eh
                mov     edx, esi
                or      edx, ebx
                and     edx, ecx
                mov     eax, esi
                and     eax, ebx
                or      edx, eax
		mov	eax, [ebp-90h]
		xor 	eax, [ebp-7Ch]
		xor	eax, [ebp-64h]
		xor	eax, [ebp-5Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-9Ch], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
		add	edi, eax
                rol     esi, 1Eh
		mov	edx, esp
                or      edx, esi
                and     edx, ebx
		mov	eax, esp
                and     eax, esi
                or      edx, eax
		mov	eax, [ebp-94h]
		xor	eax, [ebp-80h]
		xor	eax, [ebp-68h]
		xor	eax, [ebp-60h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0A0h], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	edx, edi
		or	edx, esp
                and     edx, esi
		mov	eax, edi
		and	eax, esp
                or      edx, eax
		mov	eax, [ebp-98h]
		xor	eax, [ebp-84h]
		xor	eax, [ebp-6Ch]
		xor	eax, [ebp-64h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0A4h], eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     ebx, eax
		rol	edi, 1Eh
                mov     edx, ecx
		or	edx, edi
		and	edx, esp
                mov     eax, ecx
		and	eax, edi
                or      edx, eax
		mov	eax, [ebp-9Ch]
		xor	eax, [ebp-88h]
		xor	eax, [ebp-70h]
		xor	eax, [ebp-68h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0A8h], eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ebx
                or      edx, ecx
		and	edx, edi
                mov     eax, ebx
                and     eax, ecx
                or      edx, eax
                mov	eax, [ebp-0A0h]
		xor	eax, [ebp-8Ch]
		xor	eax, [ebp-74h]
		xor	eax, [ebp-6Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0ACh], eax
		mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
		add	esp, eax
                rol     ebx, 1Eh
                mov     edx, esi
                or      edx, ebx
                and     edx, ecx
                mov     eax, esi
                and     eax, ebx
                or      edx, eax
		mov	eax, [ebp-0A4h]
		xor	eax, [ebp-90h]
		xor	eax, [ebp-78h]
		xor	eax, [ebp-70h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0B0h], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
		add	edi, eax
                rol     esi, 1Eh
		mov	edx, esp
                or      edx, esi
                and     edx, ebx
		mov	eax, esp
                and     eax, esi
                or      edx, eax
		mov	eax, [ebp-0A8h]
		xor	eax, [ebp-94h]
		xor	eax, [ebp-7Ch]
		xor	eax, [ebp-74h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0B4h], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     ecx, eax
		rol	esp, 1Eh
		mov	edx, edi
		or	edx, esp
                and     edx, esi
		mov	eax, edi
		and	eax, esp
                or      edx, eax
                mov	eax, [ebp-0ACh]
		xor	eax, [ebp-98h]
		xor	eax, [ebp-80h]
		xor	eax, [ebp-78h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0B8h], eax
		mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     ebx, eax
		rol	edi, 1Eh
                mov     edx, ecx
		or	edx, edi
		and	edx, esp
                mov     eax, ecx
		and	eax, edi
                or      edx, eax
		mov	eax, [ebp-0B0h]
		xor	eax, [ebp-9Ch]
		xor	eax, [ebp-84h]
		xor	eax, [ebp-7Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0BCh], eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax-70E44324h]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ebx
                xor     edx, ecx
		xor	edx, edi
		mov     eax, [ebp-0B4h]
                mov     [ebp-0C0h], eax
		xor	eax, [ebp-0A0h]
		xor	eax, [ebp-88h]
		xor	eax, [ebp-80h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0C4h], eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
		add	esp, eax
                rol     ebx, 1Eh
                mov     edx, esi
                xor     edx, ebx
                xor     edx, ecx
                mov     eax, [ebp-0B8h]
                mov     [ebp-0C8h], eax
		xor	eax, [ebp-0A4h]
		xor	eax, [ebp-8Ch]
		xor	eax, [ebp-84h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0CCh], eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
		add	edi, eax
                rol     esi, 1Eh
                mov	eax, [ebp-0BCh]
		mov	edx, esp
		xor	eax, [ebp-0A8h]
                xor     edx, esi
		xor	eax, [ebp-90h]
                xor     edx, ebx
		xor	eax, [ebp-88h]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0D0h], eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     ecx, eax
		rol	esp, 1Eh
		mov	eax, [ebp-0C4h]
		mov	edx, edi
		xor	eax, [ebp-0ACh]
		xor	edx, esp
		xor	eax, [ebp-94h]
                xor     edx, esi
		xor	eax, [ebp-8Ch]
		rol	eax, 1
		add	edx, eax
		mov	[ebp-0D4h], eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     ebx, eax
		rol	edi, 1Eh
		mov	eax, [ebp-0CCh]
                mov     edx, ecx
		xor	eax, [ebp-0B0h]
		xor	edx, edi
		xor	eax, [ebp-98h]
		xor	edx, esp
		xor	eax, [ebp-90h]
		rol	eax, 1
		mov	[ebp-0D8h], eax
		mov     dword [msgblock], eax
                add     edx, eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     esi, eax
                rol     ecx, 1Eh
		mov	eax, [ebp-0D0h]
                mov     edx, ebx
		xor	eax, [ebp-0C0h]
                xor     edx, ecx
		xor	eax, [ebp-9Ch]
		xor	edx, edi
		xor	eax, [ebp-94h]
		rol	eax, 1
		mov	[ebp-0DCh], eax
                mov     dword [msgblock+4], eax
                add     edx, eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
		add	esp, eax
                rol     ebx, 1Eh
		mov	eax, [ebp-0D4h]
                mov     edx, esi
		xor	eax, [ebp-0C8h]
                xor     edx, ebx
		xor	eax, [ebp-0A0h]
                xor     edx, ecx
		xor	eax, [ebp-98h]
		rol	eax, 1
		mov	[ebp-0E0h], eax
                mov     dword [msgblock+8], eax
                add     edx, eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
		add	edi, eax
                rol     esi, 1Eh
		mov	eax, [ebp-0D8h]
		mov	edx, esp
		xor	eax, [ebp-0BCh]
                xor     edx, esi
		xor	eax, [ebp-0A4h]
                xor     edx, ebx
		xor	eax, [ebp-9Ch]
		rol	eax, 1
		mov	[ebp-0E4h], eax
                mov     dword [msgblock+0Ch], eax
                add     edx, eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     ecx, eax
		rol	esp, 1Eh
		mov	eax, [ebp-0DCh]
		mov	edx, edi
		xor	eax, [ebp-0C4h]
		xor	edx, esp
		xor	eax, [ebp-0A8h]
                xor     edx, esi
		xor	eax, [ebp-0A0h]
		rol	eax, 1
		mov	[ebp-0E8h], eax
                mov     dword [msgblock+10h], eax
                add     edx, eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     ebx, eax
		rol	edi, 1Eh
		mov	eax, [ebp-0E0h]
                mov     edx, ecx
		xor	eax, [ebp-0CCh]
		xor	edx, edi
		xor	eax, [ebp-0ACh]
		xor	edx, esp
		xor	eax, [ebp-0A4h]
		rol	eax, 1
		mov	[ebp-0ECh], eax
                mov     dword [msgblock+14h], eax
                add     edx, eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     esi, eax
                rol     ecx, 1Eh
		mov	eax, [ebp-0E4h]
                mov     edx, ebx
		xor	eax, [ebp-0D0h]
                xor     edx, ecx
		xor	eax, [ebp-0B0h]
		xor	edx, edi
		xor	eax, [ebp-0A8h]
		rol	eax, 1
		mov	[ebp-0F0h], eax
                mov     dword [msgblock+18h], eax
                add     edx, eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
		add	esp, eax
                rol     ebx, 1Eh
		mov	eax, [ebp-0E8h]
                mov     edx, esi
		xor	eax, [ebp-0D4h]
                xor     edx, ebx
		xor	eax, [ebp-0C0h]
                xor     edx, ecx
		xor	eax, [ebp-0ACh]
		rol	eax, 1
		mov	[ebp-0F4h], eax
                mov     dword [msgblock+1Ch], eax
                add     edx, eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
		add	edi, eax
		mov	[ebp-4], edi
                rol     esi, 1Eh
                mov     edi, [ebp-0ECh]
		mov	edx, esp
                xor     edi, [ebp-0D8h]
                xor     edx, esi
                xor     edi, [ebp-0C8h]
                xor     edx, ebx
                xor     edi, [ebp-0B0h]
                rol     edi, 1
                mov     dword [msgblock+20h], edi
                add     edx, edi
                mov     eax, [ebp-4]
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     ecx, eax
		rol	esp, 1Eh
		mov	eax, [ebp-0F0h]
                mov     edx, [ebp-4]
		xor	eax, [ebp-0DCh]
		xor	edx, esp
		xor	eax, [ebp-0BCh]
                xor     edx, esi
		xor	eax, [ebp-0C0h]
		rol	eax, 1
		mov	[ebp-0F8h], eax
                mov     dword [msgblock+24h], eax
                add     edx, eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     ebx, eax
                rol     dword [ebp-4], 1Eh
		mov	eax, [ebp-0F4h]
                mov     edx, ecx
		xor	eax, [ebp-0E0h]
                xor     edx, [ebp-4]
		xor	eax, [ebp-0C4h]
		xor	edx, esp
		xor	eax, [ebp-0C8h]
		rol	eax, 1
		mov	[ebp-0FCh], eax
                mov     dword [msgblock+28h], eax
                add     edx, eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, ebx
                xor     edx, ecx
                xor     edx, [ebp-4]
                xor     edi, [ebp-0E4h]
		mov	eax, edi
		xor	eax, [ebp-0CCh]
		xor	eax, [ebp-0BCh]
		rol	eax, 1
		mov	[ebp-100h], eax
                mov     dword [msgblock+2Ch], eax
                add     edx, eax
                mov     eax, esi
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
		add	esp, eax
                rol     ebx, 1Eh
		mov	eax, [ebp-0F8h]
                mov     edx, esi
		xor	eax, [ebp-0E8h]
                xor     edx, ebx
		xor	eax, [ebp-0D0h]
                xor     edx, ecx
		xor	eax, [ebp-0C4h]
		rol	eax,1
		mov	[ebp-104h], eax
                mov     dword [msgblock+30h], eax
                add     edx, eax
		mov	eax, esp
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                mov	edi, [ebp-4]
		add     edi, eax
		rol     esi, 1Eh
                mov	eax, [ebp-0FCh]
		mov	edx, esp
		xor	eax, [ebp-0ECh]
                xor     edx, esi
		xor	eax, [ebp-0D4h]
                xor     edx, ebx
		xor	eax, [ebp-0CCh]
		rol	eax, 1
		mov	[ebp-108h], eax
		mov     dword [msgblock+34h], eax
                add     edx, eax
		mov	eax, edi
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     ecx, eax
		rol	esp, 1Eh
		mov	eax, [ebp-100h]
		mov	edx, edi
		xor	eax, [ebp-0F0h]
		xor	edx, esp
		xor	eax, [ebp-0D8h]
                xor     edx, esi
		xor	eax, [ebp-0D0h]
		rol	eax, 1
		mov	[ebp-10Ch], eax
                mov     dword [msgblock+38h], eax
                add     edx, eax
                mov     eax, ecx
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     ebx, eax
		rol	edi, 1Eh
		mov	eax, [ebp-104h]
                mov     edx, ecx
		xor	eax, [ebp-0F4h]
		xor	edx, edi
		xor	eax, [ebp-0DCh]
		xor	edx, esp
		xor	eax, [ebp-0D4h]
		rol	eax, 1
		mov	[ebp-110h], eax
                mov     dword [msgblock+3Ch], eax
                add     edx, eax
                mov     eax, ebx
                rol     eax, 5
                lea     eax, [edx+eax-359D3E2Ah]
                add     esi, eax
                rol     ecx, 1Eh
                mov     edx, [ebp+8]
                add     [edx], esi
                add     [edx+4], ebx
                add     [edx+8], ecx
		mov	eax, edi
                add     [edx+0Ch], eax
		mov	eax, esp
                add     [edx+10h], eax
                lea     esp, [ebp-168h]
                pop     ebx
                pop     esi
                pop     edi
                leave
                retn

SHA1Reset:
                push    ebp
                mov     ebp, esp
                mov     eax, [ebp+8]
                mov     dword [eax], 67452301h
                mov     dword [eax+4], 0EFCDAB89h
                mov     dword [eax+8], 98BADCFEh
                mov     dword [eax+0Ch], 10325476h
                mov     dword [eax+10h], 0C3D2E1F0h
                mov     dword [eax+18h], 0
                mov     dword [eax+14h], 0
                leave
                retn

SHA1Input:
                push    ebp
                mov     ebp, esp
                sub     esp, 0Ch
                push    edi
                push    esi
                push    ebx
                mov     edi, [ebp+8]
                mov     esi, [ebp+10h]
                mov     edx, [edi+14h]
                mov     ecx, edx
                shr     ecx, 3
                and     ecx, 3Fh
                mov     eax, esi
                shl     eax, 3
                add     edx, eax
                mov     [edi+14h], edx
                cmp     edx, eax
                jnb     short noincrement
                inc     dword [edi+18h]
noincrement:
                mov     eax, esi
                shr     eax, 1Dh
                add     [edi+18h], eax
                lea     eax, [esi+ecx]
                cmp     eax, 3Fh
                jbe     short endwithxor

		add	esp, 0FFFFFFFCh
                mov     ebx, 40h
                sub     ebx, ecx
		push	ebx
		mov	eax, [ebp+0Ch]
		push	eax
		lea	eax, [edi+ecx+1Ch]
		push	eax
		call	memcpy
                add     esp, 0FFFFFFF8h
                lea     eax, [edi+1Ch]
                push    eax
                push    edi
                call    SHA1ProcessMessageBlock
                add     esp, 20h
                jmp     short fortest
fornext:
                add     esp, 0FFFFFFF8h
                mov     eax, [ebp+0Ch]
                add     eax, ebx
                push    eax
                push    edi
                call    SHA1ProcessMessageBlock
                add     esp, 10h
                add     ebx, 40h
fortest:
                lea     eax, [ebx+3Fh]
                cmp     eax, esi
                jb      short fornext
                xor     ecx, ecx
                jmp     short endwithoutxor
endwithxor:
                xor     ebx, ebx
endwithoutxor:
                sub     esi, ebx
  	        lea	edi, [edi+ecx+1Ch]		
	        mov	ecx, esi
	        mov	esi, [ebp+0Ch]
	        add	esi, ebx
	        rep	movsb
                lea     esp, [ebp-18h]
                pop     ebx
                pop     esi
                pop     edi
                leave
                retn

SHA1Result:
                push    ebp
                mov     ebp, esp
                sub     esp, 1Ch
                push    edi
                push    esi
                push    ebx
                mov     esi, [ebp+0Ch]
                xor     edx, edx
loop1:
                lea     edi, [ebp-8]
                cmp     edx, 3
                setbe   al
                movzx   eax, al
                lea     ecx, [esi+14h]
                mov     [ebp-0Ch], ecx
                mov     ecx, edx
                not     ecx
                and     ecx, 3
                shl     ecx, 3
                mov     ebx, [ebp-0Ch]
                mov     eax, [ebx+eax*4]
                shr     eax, cl
                mov     [edx+edi], al
                inc     edx
                cmp     edx, 7
                jbe     short loop1
		mov	eax, [esi+14h]
		and	eax, 1F8h
		mov	edx, 1C0h
		cmp	eax, 1C0h
		jz	padnext
		jb	oki
		add	edx, 200h
oki:
		add	esp, 0FFFFFFFCh
		sub	edx, eax
		shr	edx, 3
		push	edx
		push	dword pad1
		push	esi
		call	SHA1Input
		add	esp, 10h
padnext:

                add     esp, 0FFFFFFFCh
                push    dword 8
                push    edi
                push    esi
                call    SHA1Input
                xor     edx, edx
                add     esp, 10h
loop2:
                mov     eax, edx
                and     al, 0FCh
                mov     ecx, edx
                not     ecx
                and     ecx, 3
                shl     ecx, 3
                mov     eax, [eax+esi]
                shr     eax, cl
                mov     ecx, [ebp+8]
                mov     [edx+ecx], al
                inc     edx
                cmp     edx, 13h
                jbe     short loop2
                add     esp, 18h
		
                push    ebx
                push    esi
                call    SHA1ProcessMessageBlock
                lea     esp, [ebp-28h]
                pop     ebx
                pop     esi
                pop     edi
                leave
                retn


SHA1Hash:
                push    ebp
                mov     ebp, esp
                sub     esp, 6Ch
                push    edi
                push    esi
                push    ebx
                mov     edi, [ebp+8]
                mov     esi, [ebp+0Ch]
		add	esp, 0FFFFFFF4h
                lea     ebx, [ebp-5Ch]
		push	ebx
		call	SHA1Reset
                add     esp, 0FFFFFFFCh
                push    esi
                push    edi
                push    ebx
                call    SHA1Input
		add	esp, 18h
                push    ebx
                mov     eax, [ebp+10h]
                push    eax
                call    SHA1Result
                lea     esp, [ebp-78h]
                pop     ebx
                pop     esi
                pop     edi
                leave
                retn
